SystemOrganization addCategory: #'Ma Squeak domain-Methods'!

!ClassDescription methodsFor: '*ma squeak domain' stamp: 'cmm 1/4/2004 16:15'!
maCategoryOfElement: selectorSymbol
	"Answer the category associated with the argument, element."

	^(organization categoryOfElement: selectorSymbol)
		ifNil:
			[ superclass
				ifNil: [ nil ]
				ifNotNil: [ superclass maCategoryOfElement: selectorSymbol ] ]! !

Object subclass: #MaMethodSelector
	instanceVariableNames: 'methods isCaseSensitive'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma Squeak domain-Methods'!

!MaMethodSelector commentStamp: '<historical>' prior: 0!
I'm useful for finding methods in the image.  Be wary, I was ported from VA and, though some methods have been ported, I haven't been through a full quality check yet.!

!MaMethodSelector class methodsFor: 'creation' stamp: 'cmm 2/12/2003 23:15'!
forMyCode

	^self new
		addMethodsNamed: 'ma';
		selectMethodsWhere:
			[ :each |
			((each selector size >= 3 and: [ (each selector at: 3) isUppercase ])
				or: [ each selector size >= 5 and: [ (each selector at: 5) isUppercase ] ]) ];
		addClasses: self myClasses;
		yourself! !

!MaMethodSelector class methodsFor: 'creation' stamp: 'cmm 12/20/2002 16:06'!
myClasses

	^ProtoObject withAllSubclasses
		select: 
			[ :e | 
			((e name beginsWith: 'Ma') and: [ (e name at: 3) isUppercase ]) or: [ e inheritsFrom: MaObject ] ]! !

!MaMethodSelector class methodsFor: 'creation' stamp: 'cmm 12/23/2002 11:38'!
myClassesBySystemCategory

	| answer |
	answer _ Dictionary new.
	(self myClasses reject: [ :e | e isMeta ]) collect: [ :e | (answer at: e category ifAbsentPut: [ OrderedCollection new ]) add: e ].
	^answer! !

!MaMethodSelector class methodsFor: 'creation' stamp: ''!
new

	^super new initialize
! !

!MaMethodSelector class methodsFor: 'utilities' stamp: 'cmm 1/27/2003 00:32'!
selectMethodExtensionsTo: changeSetName

	| cs selector myMethods |
	myMethods _ self forMyCode methods.
	cs _ ChangeSorter changeSetNamed: changeSetName.
	selector _ self new.
	cs changedClasses do: [ :each | selector addClass: each ].
	^selector
		selectMethods: [ :each | myMethods includes: each ];
		rejectMethodsInChangeSet: cs;
		yourself! !

!MaMethodSelector methodsFor: 'adding' stamp: 'cmm 2/17/2002 16:43'!
addAll
	"Selects all methods in the image.  This can take an incredibly
	long time.  We should analyze a faster way of doing this."

	Smalltalk allClasses do: [ :each | self addClass: each ]
! !

!MaMethodSelector methodsFor: 'adding' stamp: 'cmm 4/23/2002 00:04'!
addAllChangeSetsInCategoryNamed: aString

	(ChangeSorter changeSetCategoryNamed: aString) changeSetList
		do:
			[ :each | self addChangeSetNamed: each ]! !

!MaMethodSelector methodsFor: 'adding' stamp: 'cmm 4/23/2002 00:03'!
addAllExtendedChangeSets

	self addAllChangeSetsInCategoryNamed: 'Extended'
! !

!MaMethodSelector methodsFor: 'adding' stamp: 'cmm 2/17/2002 16:46'!
addCategories: categoryString
	"Add all methods in the system which are in the category categoryString."

	Smalltalk do:
		[ :each | | selectors |
		selectors :=
			each
				methodNamesCategorizedIn: categoryString substrings
				all: false.
		self methods
			addAll: (selectors collect: [ :eachSelector | each compiledMethodAt: eachSelector ]) ]
! !

!MaMethodSelector methodsFor: 'adding' stamp: 'cmm 4/22/2002 23:02'!
addChangeSetNamed: aString

	^self addChangeSet: (ChangeSorter changeSetNamed: aString)! !

!MaMethodSelector methodsFor: 'adding' stamp: 'cmm 4/22/2002 23:48'!
addChangeSet: aChangeSet

	| changesDictionary |
	changesDictionary _ aChangeSet methodChanges.
	changesDictionary keysAndValuesDo:
		[ :eachClassName :eachChangesDict |
		| class |
		class _ eachClassName substrings size = 1
			ifTrue:
				[ Smalltalk
					at: eachClassName
					ifAbsent: [ nil ] ]
			ifFalse:
				[ Smalltalk
					at: (eachClassName substrings first asSymbol)
					ifAbsent: [ nil ] ].
		class ifNotNil:
			[ eachClassName substrings size > 1 "if it is a class method"
				ifTrue: [ class _ class class ].
			eachChangesDict keysAndValuesDo:
				[ :eachSelector :eachChangeType |
				(#(add change) includes: eachChangeType)
					ifTrue:
						[ (class methodDict includesKey: eachSelector)
							ifTrue:
								[ self methods add: (class compiledMethodAt: eachSelector) ] ] ] ] ]
! !

!MaMethodSelector methodsFor: 'adding' stamp: 'cmm 7/26/2002 00:29'!
addClassesNamed: classNameArgumentString

	| classes |

self maMarked: 'dev'.  "not converted from visualage.."
"	classes :=
		System
			findClassUsing: classNameArgumentString
			ifCancel: [ ^OrderedCollection new ]."
	classes isClass
		ifTrue:
			[ self addClass: classes ]
		ifFalse:
			[ classes do: [ :each | self addClass: each ] ]
! !

!MaMethodSelector methodsFor: 'adding' stamp: ''!
addClasses: classesCollection

	"Adds all methods in each class in classesCollectoin"

	classesCollection do: [ :each | self addClass: each ]
! !

!MaMethodSelector methodsFor: 'adding' stamp: ''!
addClassHierarchy: aClass
	"Adds the methods in aClass as well as all of its superclasses."

	self addSuperclassHierarchy: aClass.
	self addSubclassHierarchy: aClass
! !

!MaMethodSelector methodsFor: 'adding' stamp: 'cmm 12/18/2004 18:09'!
addClass: aClass
	"Adds all methods in aClass"

	aClass selectorsDo:
		[ : each | 
		self addMethod: (MethodReference class: aClass selector: each) ]! !

!MaMethodSelector methodsFor: 'adding' stamp: 'cmm 12/16/2004 01:05'!
addMethodsNamed: aString

	ProtoObject withAllSubclassesDo:
		[ :eachClass |
		eachClass selectorsDo:
			[ : eachSelector |
			(eachSelector beginsWith: aString)
				ifTrue:
					[ self addMethod: (MethodReference class: eachClass selector: eachSelector) ] ] ]! !

!MaMethodSelector methodsFor: 'adding' stamp: ''!
addMethodsReferencingAny: aCollection
	"Add all methods whose names reference any of the the literals in aCollection."

	aCollection do: [ :each | self addMethodsReferencing: each ]
! !

!MaMethodSelector methodsFor: 'adding' stamp: 'cmm 11/16/2004 11:02'!
addMethodsReferencingInstanceVariableNamed: aString

	"Add all methods whose names reference the literal aString"
self maMarked: 'dev'.  "not converted from va"
"
	System classHierarchyRoots
		do: [ :each | self methods addAll: (each whichMethodsReferenceInstVarName: aString) ]
"! !

!MaMethodSelector methodsFor: 'adding' stamp: 'cmm 7/26/2002 00:30'!
addMethodsReferencing: aString
	"Add all methods whose names reference the literal aString"
self maMarked: 'dev'.  "not converted from va"

"
	System classHierarchyRoots
		do: [ :each | self methods addAll: (each allMethodsReferencingLiteral: aString) ]
"! !

!MaMethodSelector methodsFor: 'adding' stamp: 'cmm 12/16/2004 01:10'!
addMethodsSending: aString

	"Present a window with all that matches aString.  From
	that the user selects a list of methods that are then added
	to the receiver."

	| selectors |
	selectors := Symbol selectorsContaining: aString.
	selectors isEmpty ifTrue: [ ^self ].  "shortcut"
	ProtoObject withAllSubclasses do:
		[ :eachClass |
		selectors do:
			[ :eachSelector |
			self methods addAll:
				((eachClass allCallsOn: eachSelector)
					collect: [ : each | MethodReference class: eachClass selector: each selector ]) ] ]
! !

!MaMethodSelector methodsFor: 'adding' stamp: 'cmm 12/16/2004 01:01'!
addMethod: aMethodReference

	methods add: aMethodReference! !

!MaMethodSelector methodsFor: 'adding' stamp: ''!
addSubclassHierarchy: aClass

	"Adds the methods in aClass as well as all of its subclasses."

	aClass withAllSubclassesDo: [ :each | self addClass: each ]
! !

!MaMethodSelector methodsFor: 'adding' stamp: ''!
addSuperclassHierarchy: aClass
	"Adds the methods in aClass as well as all of its subclasses."

	aClass withAllSuperclassesDo: [ :each | self addClass: each ]
! !

!MaMethodSelector methodsFor: 'configuring' stamp: ''!
beCaseInsensitive

	isCaseSensitive := false
! !

!MaMethodSelector methodsFor: 'configuring' stamp: ''!
beCaseSensitive

	isCaseSensitive := true
! !

!MaMethodSelector methodsFor: 'accessing' stamp: 'cmm 12/26/2004 15:58'!
classes
	"Returns the set of classes that all methods in the receiver span."

	^self methods collect: [ :each | each actualClass ]
! !

!MaMethodSelector methodsFor: 'actions' stamp: ''!
clear

	self methods: Set new
! !

!MaMethodSelector methodsFor: 'initializing' stamp: ''!
initialize

	methods := Set new.
	isCaseSensitive := false
! !

!MaMethodSelector methodsFor: 'accessing' stamp: ''!
isCaseSensitive

	^isCaseSensitive
! !

!MaMethodSelector methodsFor: 'accessing' stamp: ''!
methods

	"Returns the selected methods."

	^methods
! !

!MaMethodSelector methodsFor: 'accessing' stamp: ''!
methods: aSet

	methods := aSet
! !

!MaMethodSelector methodsFor: 'removing' stamp: 'cmm 12/16/2004 01:15'!
rejectMethodsInChangeSet: aChangeSet

	self methods:
		(self methods reject:
			[ :each |
			(ChangeSorter
				allChangeSetsWithClass: each actualClass
				selector: each methodSymbol) includes: aChangeSet ])! !

!MaMethodSelector methodsFor: 'removing' stamp: 'cmm 12/16/2004 01:15'!
rejectMethodsInNoChangeSet

	| count |
	count _ 0.
	self methods:
		(self methods reject:
			[ :each |
			count _ count + 1.
			count \\ 10 = 0 ifTrue: [ ProgressNotification signal: count printString, ' methods searched.' ].
			(ChangeSorter
				allChangeSetsWithClass: each actualClass
				selector: each methodSymbol) isEmpty ])! !

!MaMethodSelector methodsFor: 'removing' stamp: 'cmm 12/16/2004 01:18'!
selectCategories: anArray
	"Select all methods from the receiver which are in anArray of category
	names."

	self methods: (
		self classes
			inject: Set new
			into:
				[ :set :eachClass | 
				anArray
					inject: set
					into:
						[ :sameSet :eachCategory |
						sameSet addAll: ((eachClass organization listAtCategoryNamed: eachCategory)
							collect: [ :eachClassSelector | MethodReference class: eachClass selector: eachClassSelector ]); yourself ] ])! !

!MaMethodSelector methodsFor: 'removing' stamp: 'cmm 12/16/2004 01:18'!
selectClassesNamed: classNameArgumentString

	"Filter out all methods in the receiver that don't belong to one of the
	classes that begin with classNameArgumentString."

	self methods: (
		self methods select:
			[ :each |
			each actualClass printString
				maBeginsWith: classNameArgumentString
				ignoringCase: self isCaseSensitive ])
! !

!MaMethodSelector methodsFor: 'removing' stamp: 'cmm 12/16/2004 01:18'!
selectClassHierarchy: aClass

	"Select all methods in the receiver which exist in aClass as
	well as all of its super and subclasses."

	| hierarchy |
	hierarchy _ (Array with: aClass) , aClass allSubclasses , aClass allSuperclasses.
	self methods: (self methods select: [ :each | hierarchy includes: each actualClass ])
! !

!MaMethodSelector methodsFor: 'removing' stamp: 'cmm 12/16/2004 01:18'!
selectClass: aClass

	"Select all methods in the receiver which exist in an aClass"

	self methods: (self methods select: [ :each | each actualClass == aClass ])
! !

!MaMethodSelector methodsFor: 'removing' stamp: 'cmm 12/16/2004 01:19'!
selectMethodNamesContaining: aString
	"Removes all but the method names that include aString"

	self methods: (
		self methods select:
			[ : each |
			each methodSymbol asString
				maIncludesString: aString
				ignoringCase: self isCaseSensitive not ])! !

!MaMethodSelector methodsFor: 'removing' stamp: 'cmm 12/16/2004 01:22'!
selectMethodsContainingString: aString
	"Returns all of the methods in the image containing string aString.  This can
	take quite a bit of time."

	self methods: (
		self methods select:
			[ :each |
			each sourceString notNil
				and: [ (each sourceCode maIncludesString: aString)
				or: [ each comment maIncludesString: aString ] ] ])
! !

!MaMethodSelector methodsFor: 'removing' stamp: 'cmm 4/23/2002 00:14'!
selectMethodsInChangeSetNamed: aString

	^self selectMethodsInChangeSet: (ChangeSorter changeSetNamed: aString)
! !

!MaMethodSelector methodsFor: 'removing' stamp: 'cmm 12/16/2004 01:22'!
selectMethodsInChangeSet: aChangeSet

	self methods:
		(self methods select:
			[ :each |
			(ChangeSorter
				allChangeSetsWithClass: each actualClass
				selector: each methodSymbol) includes: aChangeSet ])! !

!MaMethodSelector methodsFor: 'removing' stamp: 'cmm 12/16/2004 01:23'!
selectMethodsInNoChangeSet

	| count |
	count _ 0.
	self methods:
		(self methods select:
			[ :each |
			count _ count + 1.
			count \\ 10 = 0 ifTrue: [ ProgressNotification signal: count printString, ' methods searched.' ].
			(ChangeSorter
				allChangeSetsWithClass: each actualClass
				selector: each methodSymbol) isEmpty ])! !

!MaMethodSelector methodsFor: 'removing' stamp: 'cmm 12/16/2004 01:23'!
selectMethodsNamed: aString
	"Removes all but the method names that begin with aString"

	self methods: (
		self methods select:
			[ :each |
			each methodSymbol asString
				maBeginsWith: aString
				ignoringCase: self isCaseSensitive not ])! !

!MaMethodSelector methodsFor: 'removing' stamp: 'cmm 11/22/2003 18:05'!
selectMethodsReferencingAny: anArray

	self methods: (
		self methods select:
			[ :each | anArray anySatisfy: [ :eachString | each referencesLiteral: eachString ] ])
! !

!MaMethodSelector methodsFor: 'removing' stamp: ''!
selectMethodsReferencingInstanceVariableNamed: aString

	"Add all methods whose names reference the instance variable aString"

	self methods: (self methods select: [ :each | each referencesInstVar: aString ])
! !

!MaMethodSelector methodsFor: 'removing' stamp: ''!
selectMethodsReferencing: aString

	"Add all methods whose names reference the instance variable aString"

	self methods: (self methods select: [ :each | each referencesLiteral: aString ])
! !

!MaMethodSelector methodsFor: 'removing' stamp: 'cmm 11/22/2003 18:05'!
selectMethodsSendingAny: anArray
	"Select all methods which send aString"

	self methods: (
		self methods select:
			[ :each |
			anArray anySatisfy:
				[ :eachSelector |
				(each sendsNormalSelector: eachSelector)
					or: [ each sendsSpecialSelector: eachSelector ] ] ])
! !

!MaMethodSelector methodsFor: 'removing' stamp: ''!
selectMethodsSending: selector

	"Select all methods which send aString"

	self methods: (
		self methods select:
			[ :each |
			(each sendsNormalSelector: selector) or: [ each sendsSpecialSelector: selector ] ])
! !

!MaMethodSelector methodsFor: 'removing' stamp: 'cmm 7/27/2002 18:26'!
selectMethodsWhere: aBlock

	self methods: (self methods select: aBlock)! !

!MaMethodSelector methodsFor: 'removing' stamp: 'cmm 1/27/2003 00:24'!
selectMethods: aBlock

	methods _ methods select: aBlock! !

!MaMethodSelector methodsFor: 'removing' stamp: ''!
selectPrivate

	self methods: (self methods select: [ :each | each isPrivate ])
! !

!MaMethodSelector methodsFor: 'removing' stamp: ''!
selectPublic

	self methods: (self methods select: [ :each | each isPublic ])
! !

!MaMethodSelector methodsFor: 'removing' stamp: 'cmm 12/16/2004 01:24'!
selectSubclassHierarchy: aClass
	"Select all methods in the receiver which exist in a aClass as
	well as all of aClass subclasses."

	| hierarchy |

	hierarchy := (Array with: aClass) , aClass allSubclasses.
	self methods: (self methods select: [ :each | hierarchy includes: each actualClass ])
! !

!MaMethodSelector methodsFor: 'removing' stamp: 'cmm 12/16/2004 01:24'!
selectSuperclassHierarchy: aClass

	"Select all methods in the receiver which exist in a aClass as
	well as all of aClass superclasses."

	| hierarchy |

	hierarchy := aClass withAllSuperclasses.
	self methods: (self methods select: [ :each | hierarchy includes: each actualClass ])
! !
